/*
	GetRandom.java
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import com.elsid.trellis.*;

public class GetRandom extends BaseModule
{
	private static final String ACTION_GET_NUMBER = "random";
	private static final String TITLE_ENTRY = "Create Random Numbers";
	private static final String MENU_ENTRY = "Make Random Number";
	private static final String ITEM_ENTRY = "Do It";
	
	JTextField label;
	
	// Constructors
	
	public GetRandom( Trellis base_gui  )
	{
		super( base_gui );
		JButton fetch;
		
		setTitle(  TITLE_ENTRY  );		
		setSize( 200, 100 );	
		getContentPane().setLayout( new BorderLayout() );		
		getContentPane().add( "North", fetch = new JButton( MENU_ENTRY ));
		fetch.addActionListener( new ActionListener()
		{
			public void actionPerformed( ActionEvent e )
			{
				doGetRandom();
			}
		});
		
		label = new JTextField();
		label.setHorizontalAlignment( JTextField.CENTER );
		label.setBackground( Color.white );	
		label.setBorder( BorderFactory.createLoweredBevelBorder() );
		
		getContentPane().add( "Center", label );
	
		// Set up the menu bar
		
		// Add a new menu and an item.
		addMenuItem( MENU_ENTRY, ITEM_ENTRY, 
		ACTION_GET_NUMBER );			
		// Create the menu bar
		initMenuBar();

		// Disable the basic menu set.
		enableBasicMenus( false );

		// Enable the Edit - Copy menu item.
		enableMenuItemName( Menus.get(Menus.EDIT), 
		Menus.get(Menus.COPY), true );
		
		// Set up the tool bar
		
		addToolSeparator();

		// Add a new tool to generate the random number.

		addTool( null, ACTION_GET_NUMBER, MENU_ENTRY );

		// Create the tool bar.
		initToolBar();

		// Disable the basic tool set, we don' t need them.
		enableBasicTools( false );

		//  Enable the Copy Tool
		enableToolAction(Tools.get( Tools.COPY_ACTION ), true );
				
		setVisible( true );
	}
	
	// Public Methods Overloaded from super class
	
	public void doClose()
	{
		setVisible( false );
		dispose();
	}
	
	public void doCopy()
	{
		String str = null;
		
		str = label.getSelectedText();
		if( str != null && str.length() > 0 )
			setClipboardString( str );
	}
	
	public void doLocalMenuCommand( String command )
	{
		if( command.equals( ACTION_GET_NUMBER ) )
			doGetRandom(); 
	}
	
	public void doAbout()
	{
		JOptionPane.showMessageDialog( base_gui,
				"Generate Unique ID's\nVersion 0.1\nCopyright (c)" + 
				"2001\nELSID Software Systems LTD. Ottawa," +  
				"CANADA", Strings.get( Strings.MENU_ABOUT ), 
				JOptionPane.PLAIN_MESSAGE);
	}
	
	public void doHelp()
	{
		JOptionPane.showMessageDialog( base_gui, "Produces a random key." ,
				Strings.get( Strings.MENU_HELP ), 
				JOptionPane.PLAIN_MESSAGE);
	}
	
	// Other public methods	
	
	public void doGetRandom()
	{
		label.setText( "" + (int)(Math.random() * 100000) );		
	}	
}

